fun{MkInitEnv}
   R={NewDictionary} in
   for X in {Arity BIs} do
      R.X:=BIs.X.var
   end
   R
end
fun{MkInitStore}
   R=store(ops:OPs ...) in
   for X in {Record.toList BIs} do
      V=X.var in
      R^V=var(unit:X V:R^V)
   end
   R
end
CellVal={NewName}
fun{MkBIArith F T1 T2 A}
   BIVal(opcode:fun{$ [Id1 Id2 Id3] E Store Stack Trans}
		   if {IsDet Store.(E.Id2).unit} andthen {IsDet Store.(E.Id3).unit}then 
		      try
			 V={F Store.(E.Id2).unit Store.(E.Id3).unit} in
			 Trans=T1
			 (kVarVal(Id1 V)#E)|Stack
		      catch _ then
			 Trans=T2
			 (kRaise(k('Type error'))#E)|Stack
		      end
		   else
		      if {IsDet Store.(E.Id2).unit} then
			 (stop(Id3)#E)|(kVarOp2(Id1 A Id2 Id3)#E)|Stack
		      else
			 (stop(Id2)#E)|(kVarOp2(Id1 A Id2 Id3)#E)|Stack
		      end
		   end
		end)
end
OPs=ops('@':BIVal(opcode:fun{$ [Id1 Id2] E Store Stack Trans}
			    if {IsDet Store.(E.Id2).unit} then 
			       case Store.(E.Id2).unit
			       of CellVal(_ C) then
				  NId=if Id1=='Content' then 'RealContent' else 'Content' end in
				  Trans='op@'
				  (kVarVar(Id1 NId)#{AdjoinAtEnv E NId @C})|Stack
			       else
				  Trans='op@typeerror'
				  (kRaise(k('Type error'))#E)|Stack
			       end
			    else
			       (stop(Id2)#E)|(kVarOp1(Id1 '@' Id2)#E)|Stack
			    end
			 end)
	'~':BIVal(opcode:fun{$ [Id1 Id2] E Store Stack Trans}
			    if {IsDet Store.(E.Id2).unit} then 
			       try
				  V=~(Store.(E.Id2).unit) in
				  Trans='op~'
				  (kVarVal(Id1 V)#E)|Stack
			       catch _ then
				  Trans='op~typeerror'
				  (kRaise(k('Type error'))#E)|Stack
			       end
			    else
			       (stop(Id2)#E)|(kVarOp1(Id1 '~' Id2)#E)|Stack
			    end
			 end)
	'+':{MkBIArith Number.'+' 'op+' 'op+typeerror' '+'}
	'-':{MkBIArith Number.'-' 'op-' 'op-typeerror' '-'}
	'*':{MkBIArith Number.'*' 'op*' 'op*typeerror' '*'}
	'/':{MkBIArith Float.'/' 'op/' 'op/typeerror' '/'}
	'mod':{MkBIArith Int.'mod' 'opmod' 'opmodtypeerror' 'mod'}
	'div':{MkBIArith Int.'div' 'opdiv' 'opdivtypeerror' 'div'}
	'.':BIVal(opcode:fun{$ [Id1 Id2 Id3] E Store Stack Trans}
			    if {IsDet Store.(E.Id2).unit} andthen {IsDet Store.(E.Id3).unit} then 
			       case Store.(E.Id2)
			       of RecVal(R) then
				  if {HasFeature R Store.(E.Id3).unit} then
				     NId=if Id1=='Content' then 'RealContent' else 'Content' end
				     V=R.(Store.(E.Id3).unit) in
				     Trans='op.'
				     (kVarVar(Id1 NId)#{AdjoinAtEnv E NId V})|Stack
				  else
				     Trans='op.featureerror'
				     (kRaise(k('Unknown feature'))#E)|Stack
				  end
			       else
				  Trans='op.typeerror'
				  (kRaise(k('Type error'))#E)|Stack
			       end
			    else
			       if {IsDet Store.(E.Id2).unit} then
				  (stop(Id3)#E)|(kVarOp2(Id1 '.' Id2 Id3)#E)|Stack
			       else
				  (stop(Id2)#E)|(kVarOp2(Id1 '.' Id2 Id3)#E)|Stack
			       end
			    end
			 end)
	':=':BIVal(opcode:fun{$ [Id1 Id2 Id3] E Store Stack Trans}
			     if {IsDet Store.(E.Id2).unit} then 
				case Store.(E.Id2).unit
				of CellVal(_ C) then
				   NId=if Id1=='Content' then 'RealContent' else 'Content' end
				   V=C:=(E.Id3) in
				   Trans='op:='
				   (kVarVar(Id1 NId)#{AdjoinAtEnv E NId V})|Stack
				else
				   Trans='op:=typeerror'
				   (kRaise(k('Type error'))#E)|Stack
				end
			     else
				(stop(Id2)#E)|(kVarOp2(Id1 '.' Id2 Id3)#E)|Stack
			     end
			  end)
	/*'.:=':BIVal()*/ %2do
	'==':BIVal(opcode:fun{$ [Id1 Id2 Id3] E Store Stack Trans}
			     if {Member E.Id3 {RecordC.reflectArity Store.(E.Id3)}} then
				Trans='op==eq'
				(kVarVal(Id1 true)#E)|Stack
			     else
				if {IsDet Store.(E.Id2).unit} then
				   if {IsDet Store.(E.Id3).unit} then
				      U=Store.(E.Id2).unit
				      V=Store.(E.Id3).unit in
				      if U==V then Trans='op==same' (kVarVal(Id1 true)#E)|Stack
				      else
					 case U#V
					 of RecVal(_)#RecVal(_) then
					    case {TestEqual E.Id2 E.Id3 Store}
					    of true then
					       Trans='op==' (kVarVal(Id1 true)#E)|Stack
					    [] false then
					       Trans='op==incomp' (kVarVal(Id1 true)#E)|Stack
					    [] A#B#C then
					       IdL=if Id1=='Left' then 'RealLeft' else 'Left' end
					       IdR=if Id1=='Right' then 'RealRight' else 'Right' end
					       IdC=if Id1=='Cond' then 'RealCond' else 'Cond' end
					       NE2={AdjoinEnv E [IdL#A IdR#B]}
					       NE1={AdjoinAtEnv NE2 IdC C}
					    in
					       (stop(C)#NE1)|(kVarOp2(Id1 '==' IdL IdR)#NE2)|Stack
					    end
					 else
					    Trans='op==incomp' (kVarVal(Id1 false)#E)|Stack
					 end
				      end
				   else
				      (stop(Id3)#E)|(kVarOp2(Id1 '==' Id2 Id3)#E)|Stack
				   end
				else
				   (stop(Id2)#E)|(kVarOp2(Id1 '==' Id2 Id3)#E)|Stack
				end
			     end
			  end)
	'\\=':BIVal(opcode:fun{$ [Id1 Id2 Id3] E Store Stack Trans}
			      case {OPs.'=='.opcode [Id1 Id2 Id3] E Store Stack _}
			      of (stop(Id2)#E)|(kVarOp2(Id1 '==' Id2 Id3)#E)|Stack then
				 (stop(Id2)#E)|(kVarOp2(Id1 '\\=' Id2 Id3)#E)|Stack
			      [] (kVarVal(Id1 false)#E)|Stack then
				 Trans='op\\='
				 (kVarVal(Id1 true)#E)|Stack
			      [] (kVarVal(Id1 true)#E)|Stack then
				 Trans='op\\=false'
				 (kVarVal(Id1 false)#E)|Stack
			      end
			   end)
	'<':{MkBIArith Value.'<' 'op<' 'op<typeerror' '<'}
	'>':{MkBIArith Value.'>' 'op>' 'op>typeerror' '>'}
	'=<':{MkBIArith Value.'=<' 'op=<' 'op=<typeerror' '=<'}
	'>=':{MkBIArith Value.'>=' 'op>=' 'op>=typeerror' '>='}
       )
BIs=bis('NewCell':BIVal(
		     arity:2
		     name:'newcell'
		     var:{NewName}
		     code:fun{$ [Id1 Id2] E Store Stack Trans}
			     if {IsDet Store.(E.Id2).unit} then
				Trans='binewcellerror'
				(kRaise(k('Unification error'))#E)|Stack
			     else
				Trans='binewcell'
				Store.(E.Id2).unit=CellVal({NewName} {NewCell E.Id1})
				Stack
			     end
			  end
		     ))
fun{TestEqual V1 V2 Store}
   case {TestEqualL V1 V2 Store memo(...)}
   of true then true
   [] false then false
   [] L#V then
      Left={NewName}
      Right={NewName}
   in
      Store^Left=var(unit:RecVal({MakeTuple '#' {Length L}}) Left:Store^Left)
      Store^Right=var(unit:RecVal({MakeTuple '#' {Length L}}) Left:Store^Right)
      for
	 X#Y in L
	 I in 1..{Length L}
      do
	 Store.Left.unit.1.I=X
	 Store.Right.unit.1.I=Y
      end
      Left#Right#V
   end
end
fun{TestEqualL V1 V2 Store Memo}
   if {IsDet Memo^V1^V2} andthen Memo^V1^V2 then true
   elseif {Member V1 {RecordC.reflectArity Store.V2}} then
      Memo^V1^V2=true true
   elseif {Member V1 {RecordC.reflectArity Store^unit}} andthen {Member V2 {RecordC.reflectArity Store.unit.V1}} then
      Memo^V1^V2=true true
   else
      if {IsDet Store.V1.unit} then
	 if {IsDet Store.V2.unit} then
	    U=Store.V1.unit
	    V=Store.V2.unit in
	    if U==V then true
	    else
	       case U#V
	       of RecVal(U)#RecVal(V) then
		  if {Label U}=={Label V} andthen {Arity U}=={Arity V} then
		     {FoldL for
			       I in {Arity U}
			       collect:Col
			    do
			       {Col {TestEqualL U.I V.I Store Memo}}
			    end
		      fun{$ Acc X}
			 case X
			 of true then Acc
			 [] false then false
			 [] L#V then
			    case Acc
			    of true then L#V
			    [] false then false
			    [] L2#_ then {Append L L2}#V
			    end
			 end
		      end
		      true
		     }
		  else
		     Memo^V1^V2=false
		     false
		  end
	       else
		  Memo^V1^V2=false
		  false
	       end
	    end
	 else
	    Memo^V1^V2=true
	    [V1#V2]#V2
	 end
      else
	 Memo^V1^V2=true
	 [V1#V2]#V1
      end
   end
end