\insert KParser.oz
declare
fun{AddLB X}X#"\n" end
\ifndef Compile
   F
\endif
in
functor
\ifndef Compile
   F
\endif
import
   QTk at 'x-oz://system/wp/QTk.ozf'
   RecordC
\ifdef Compile
   Application
\endif
export
   Launch
define
   \insert Interp.oz
   \insert BI.oz
   \insert Driver.oz
   proc{Launch}
      TxtH
      BefH
      AftH
      BefSH
      AftSH
      PrevH
      SuccH
      RuleH
      Ss
      CurS={NewCell Ss}
      proc{Go}
	 S={ParseStatements {Lex {Append {TxtH get($)} " "}} $#nil true}
      in
	 Ss={States [S#{MkInitEnv}] {MkInitStore}}
	 {D1 hide()}
	 {Update}
	 {D2 show()}
      end
      proc{Update}
	 RS=@CurS
	 LS=RS.1
      in
	 {BefH set(state:normal)}
	 {BefSH set(state:normal)}
	 {AftH set(state:normal)}
	 {AftSH set(state:normal)}
	 {RuleH set(state:normal)}
	 if LS.1==nil then
	    {PrevH set(state:disabled)}/*{PrevH set(text:"OO")}*/
	 else
	    {PrevH set(state:normal)}/*{PrevH set(text:"<=")}*/
	 end
	 case RS.2.stack
	 of pair(_ _)|_ then {SuccH set(state:normal)}/*{SuccH set(text:"=>")}*/
	 else {SuccH set(state:disabled)}/*{SuccH set(text:"OO")}*/
	 end
	 {BefH set(nil)}
	 {AftH set(nil)}
	 {RuleH set(nil)}
	 if {IsDet RS.2.trans} then {RuleH set(RS.2.trans)} end
	 {BefSH set({MapToTuple LS.2.store AddLB})}
	 {AftSH set({MapToTuple RS.2.store AddLB})}
	 for E in RS.2.stack do
	    case E of txt(T) then
	       {AftH newWindow('end' label(init:T) _)}
	    [] pair(T1 T2) then
	       {AftH newWindow('end' td(lr(bg:white
					   label(bg:white justify:left init:T1)
					   tdspace(bg:white width:10 glue:ns)
					   tdspace(bg:gray width:1 glue:ns)
					   tdspace(bg:white width:10 glue:ns)
					   label(bg:white justify:left init:T2))
					lrspace(bg:black width:2 glue:ew)
				       ) _)}
	    end
	    {AftH insert('end' "\n")}
	 end
	 for E in LS.2.stack do
	    case E of txt(T) then
	       {BefH newWindow('end' label(init:T) _)}
	    [] pair(T1 T2) then
	       {BefH newWindow('end' td(lr(bg:white
					   label(bg:white justify:left init:T1)
					   tdspace(bg:white width:10 glue:ns)
					   tdspace(bg:gray width:1 glue:ns)
					   tdspace(bg:white width:10 glue:ns)
					   label(bg:white justify:left init:T2))
					lrspace(bg:black width:2 glue:ew)
				       ) _)}
	    end
	    {BefH insert('end' "\n")}
	 end
	 {BefH set(state:disabled)}
	 {BefSH set(state:disabled)}
	 {RuleH set(state:disabled)}
	 {AftH set(state:disabled)}
	 {AftSH set(state:disabled)}
      end
      proc{Next}(N in '||'(_ _ N)=CurS:=N) thread {Update}end end
      proc{Prev}(N in '||'(N _ _)=CurS:=N) thread {Update}end end
      D1={QTk.build td(lr(glue:ew tbbutton(text:"Go" glue:w action:Go))
		       text(glue:nsew handle:TxtH bg:white tdscrollbar:true))}
      D2={QTk.build td(lr(glue:ew
			  button(text:"<=" handle:PrevH glue:w action:Prev) %tbbutton doesn't recognize parameter state.
			  button(text:"=>" handle:SuccH glue:w action:Next))
		       lr(td(text(glue:nsew handle:BefH bg:white state:disabled)
			     text(glue:nsew handle:BefSH bg:white state:disabled))
			  td(text(glue:nsew handle:AftH bg:white state:disabled)
			     text(glue:nsew handle:AftSH bg:white state:disabled)))
		       text(glue:nsew handle:RuleH bg:white state:disabled)
\ifdef Compile
		       action:proc{$}
				 {Application.exit 0}
			      end
\endif
		      )}
   in
      {D1 show()}
   end
   {Launch}
end
\ifndef Compile
{Apply [F] _}
\endif